//--------------------------------------------------------------------
//		Timescale
//		Means that if you do #1 in the initial block of your
//		testbench, time is advanced by 1ns instead of 1ps
//--------------------------------------------------------------------
`timescale 1ns / 1ps
//--------------------------------------------------------------------

//--------------------------------------------------------------------
//		The Lab4Basic Circuit
//		See Lab guide for schematic of this circuit
//--------------------------------------------------------------------

module Lab4Basic(
		//------------------------------------------------------------
		//		System Inputs
		//------------------------------------------------------------
		Clock,
		Reset,
		//------------------------------------------------------------
		
		//------------------------------------------------------------
		//		Lab4Basic I/O
		//------------------------------------------------------------
		In,
		Out
		//------------------------------------------------------------
	);

	//----------------------------------------------------------------
	//		Parameters
	//----------------------------------------------------------------
	parameter ResetValue	= 2'b10;
	//----------------------------------------------------------------

	//----------------------------------------------------------------
	//		System Inputs
	//----------------------------------------------------------------
	input					Clock;
	input					Reset;
	//----------------------------------------------------------------

	//----------------------------------------------------------------
	//		Lab4Basic I/O
	//----------------------------------------------------------------
	input					In;
	output wire				Out;
	//----------------------------------------------------------------

	//----------------------------------------------------------------
	//		Signal Declarations
	//----------------------------------------------------------------
	wire					A;
	reg						B, C;
	//----------------------------------------------------------------

	//----------------------------------------------------------------
	//		Assigns
	//----------------------------------------------------------------
	assign A 	= In ^ C;
	assign Out 	= C;
	//----------------------------------------------------------------

	//----------------------------------------------------------------
	//		Behavioral Description
	//----------------------------------------------------------------
	always @(posedge Clock) begin
		if (Reset) B <= ResetValue[1];
		else B <= A;
	end
	
	always @(posedge Clock) begin
		if (Reset) C <= ResetValue[0];
		else C <= B;
	end
	//----------------------------------------------------------------

endmodule
